/* Filename: RanGene_intel.c */
/* 17-Apr-2011 */
/******************************************************/
/* This function gives 2 or 3 point random number,    */
/* whose probability is P(x=-1)=P(x=1)=1/2 or         */
/* P(x=-1)=P(x=1)=1/6 and P(x=0)=2/3. Here, x means   */
/* a random variable.                                 */
/******************************************************/

#include <stdio.h>

#define RMAX    4294967291UL /* (2^32-4)-1 */
#define HALF    2147483645UL /* (2^32-4)/2-1 */
#define ONE6TH   715827881UL /* (2^32-4)/6-1 */
#define FIVE6TH 3579139409UL /* (2^32-4)5/6-1 */

unsigned long genrand_int32(void);

int ran_gene_using_genrand_int32(int traject, int wdim,
				 char ran2p[], char ran3p[]) {
  /* When an error occurs, this function will return a non-zero value. */
  
  unsigned long rand;
  int i, j, ibase, wdimM1, ibase2p, j2p;

  wdimM1=wdim-1;
  
  for (i=ibase=ibase2p=0;i<traject;i++) {
    for (j2p=0; j2p<wdimM1; j2p++) {
      rand = genrand_int32();
      while (RMAX<rand) {
	rand = genrand_int32();
      }
      if (HALF>=rand) {
	ran2p[ibase2p+j2p]=-1;
      } else {
	ran2p[ibase2p+j2p]=1;
      }
    }
    ibase2p+=wdimM1;
    for (j=0; j<wdim; j++) {
      rand = genrand_int32();
      while (RMAX<rand) {
	rand = genrand_int32();
      }
      if (ONE6TH>=rand) {
	ran3p[ibase+j]=-1;
      } else if (FIVE6TH>=rand) {
	ran3p[ibase+j]=0;
      } else {
	ran3p[ibase+j]=1;
      }
    }
    ibase+=wdim;
  } /* End of the loop for i. */

  return 0;
}
